package solatium.blockchain;

import lombok.Getter;

import java.util.Date;

@Getter
public final class TransactionBlock implements Block {

    private final String previousHash;
    private final Transaction data;
    private final long timestamp;

    public TransactionBlock(String previousHash, Transaction data, long timestamp) {
        this.previousHash = previousHash;
        this.data = data;
        this.timestamp = timestamp;
    }

    @Override
    public String getDataToHash() {
        return data.toString() + timestamp;
    }

    @Override
    public HashedBlock getHashed() {
        return new HashedBlock(this, new Sha256Hash(getDataToHash(), previousHash).getHash());
    }

    @Override
    public String toString() {
        return "Block{" +
                "previousHash='" + previousHash + '\'' +
                ", data='" + data + '\'' +
                ", timestamp=" + timestamp +
                '}';
    }
}
