package solatium.gui;

import solatium.auth.*;
import solatium.interfaces.*;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;

public class Login extends JFrame implements ActionListener {

    private JLabel errorMsg;
    private JTextField idField;
    private JTextField pwField;

    public Login() {
        setTitle("Login - Solatium");

        JPanel panel = new JPanel();
        setContentPane(panel);
        setVisible(true);

        JButton loginBtn = new JButton("Login");
        loginBtn.setName("loginBtn"); // important for testing and later referencing
        loginBtn.addActionListener(this);

        idField = new JTextField(20);
        idField.setName("idField");
        pwField = new JTextField(20); // Maybe use JPasswordField?
        pwField.setName("pwField");

        errorMsg = new JLabel();
        errorMsg.setName("errorMsg");


        add(idField);
        add(pwField);
        add(loginBtn);
        add(errorMsg);

        setSize(300, 125);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        Verification auth = new Verification(new UserDataBase());

        boolean isAuth = auth.verifiy(idField.getText(), pwField.getText());

        if(isAuth) {

            UserDataBase userDB = new UserDataBase();
            Customer user = userDB.getUser(idField.getText());

            new HomeScreen(user);

            dispatchEvent(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
        } else {
            errorMsg.setText("Wrong Password");
        }
    }
}
